/*
    This file is part of the UNF library / toolset
    Copyright (C) 2000 Steffen Kaiser

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* $RCSfile: OFNUM.C $
   $Locker: ska $	$Name:  $	$State: Exp $

	Output a number in current output radix and make sure,
	at least "length" characters are written.

*/

#include "unf.loc"

#ifdef _MICROC_
#endif
#include <limits.h>

#include "unf_post.loc"

#ifdef RCS_Version
static char const rcsid[] = 
	"$Id: OFNUM.C 1.2 2000/04/29 04:44:42 ska Exp ska $";
#endif

void ofnum(int length, unsigned long value)
{	char buf[sizeof(value) * CHAR_BIT + 1];	/* buffer if radix == 2 */
	int radix;
	char *p;
	unsigned frac;

	radix = orx;
	if(radix < 2)		/* all special radixs default to decimal (10) */
		radix = 10;

	while(length > sizeof(buf) - 1) {
		oc(' ');
		--length;
	}

	p = buf + sizeof(buf);
	*--p = '\0';		/* end of string marker of generated number */
	if(value)
		do {
			*--p = '0' + (UBYTE)(frac = (unsigned)(value % radix));
			if(frac >= 10)
				*p += 'A' - '0';
		} while((value /= radix) != 0);
	else *--p = '0';

	while(length >= sizeof(buf) - (p - buf))
		*--p = ' ';

	os(p);
}
