/*
    This file is part of the UNF library / toolset
    Copyright (C) 2000 Steffen Kaiser

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* $RCSfile: oFTerm.c $
   $Locker: ska $	$Name:  $	$State: Exp $

	Output a full table 5 (filename termination characters).

*/

#include "unf.loc"

#ifndef _MICROC_
#include <stddef.h>
#endif

#include "unf_post.loc"

#ifdef RCS_Version
static char const rcsid[] = 
	"$Id: oFTerm.c 1.2 2000/04/29 04:44:42 ska Exp ska $";
#endif

void oFTerm(struct nlsFnamTerm *nls)
{
	olabelc(5, "Filename Termination Characters");
	oo("make_size");
	oouc("go_forward", 1, "skip one dummy byte");		
	otopen();		/* Permittable characters */
	otbf(nls->firstCh);
	otbf(nls->lastCh);
	otc("Permittable characters");
	oouc("go_forward", 1, "skip one dummy byte");		
	otopen();		/* Excluded characters */
	otbf(nls->firstExcl);
	otbf(nls->lastExcl);
	otc("Excluded characters (from above range)");
	oouc("go_forward", 1, "skip one dummy byte");		
	otopen();			/* number of enumerated chars */
	otbf(nls->numSep);
	otc("Number of enumerated excluded characters");
	ott((UBYTE*)&nls->separators, nls->numSep);
	oou("is_offset"
	 , offsetof(struct nlsFnamTerm, separators)
	   - offsetof(struct nlsFnamTerm, dummy1) + nls->numSep);
	oend();
}
