/*
    This file is part of the UNF library / toolset
    Copyright (C) 2000 Steffen Kaiser

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* $RCSfile: yesno.c $
   $Locker: ska $	$Name:  $	$State: Exp $

	Displays all yes/no prompt characters.

*/

#include <stdio.h>
#include <dos.h>

void pr(int i, char *yesno)
{	printf("%3u (%c) = %s\n", i, i>32? i: ' ', yesno);
}

void pr_dbcs(unsigned lead, unsigned tail, char *yesno)
{	printf("%u (%c%c) = %s\n", (lead << 8) + tail, lead, tail, yesno);
}

void far *
get_dbcs_table()
{
	union REGS r;
	struct SREGS sr;
	
	r.x.si = 0;
	sr.ds = 0;
	r.x.ax = 0x6300;
	intdosx(&r, &r, &sr);
	
	return MK_FP(sr.ds, r.x.si);
}

int
is_dbcs_lead(unsigned char c, const void far *dbcs_table)
{
	int rc = 0;
	unsigned char far *dbcs = (unsigned char far *)dbcs_table;
	
	if (!dbcs) return 0;
	while(1) {
		if (dbcs[0] == 0 && dbcs[1] == 0) break;
		if (dbcs[0] <= c && dbcs[1] >= c) {
			rc = 1;
			break;
		}
		dbcs += 2;
	}
	return rc;
}

void
yesno_dbcs(const void far *dbcs_table)
{
#if !defined(__TURBOC__)
    union REGS r;
#endif
	unsigned lead, tail;
	unsigned n;
	
	for (lead = 0x01; lead <= 0xff; lead++) {
		if (is_dbcs_lead(lead, dbcs_table)) {
			for(tail = 0; tail <= 0xff; tail++) {
#if defined(__TURBOC__)
				_DH = lead;
				_DL = tail;
				_AX = 0x6523;
				geninterrupt(0x21);
				switch(_AX) {
#else
                r.h.dh = lead;
                r.h.dl = tail;
                intdos(&r, &r);
                switch(r.x.ax) {
#endif
					case 1: pr_dbcs(lead, tail, "yes"); break;
					case 0: pr_dbcs(lead, tail, "no"); break;
				}
			}
		}
	}
}


main(void)
{	
#if !defined(__TURBOC__)
    union REGS r;
#endif
	unsigned i;
	int yeschars = 0, nochars = 0;

	for(i = 0; ++i < 256;) {
#if defined(__TURBOC__)
		_DL = i;
		_AX = 0x6523;
		geninterrupt(0x21);
		switch(_AX) {
#else
        r.h.dl = i;
        r.x.ax = 0x6523;
        intdos(&r, &r);
        switch(r.x.ax) {
#endif
			case 1: pr(i, "yes"); yeschars++; break;
			case 0: pr(i, "no"); nochars++; break;
		}
	}
	
	if (yeschars == 0 && nochars == 0) yesno_dbcs(get_dbcs_table());

	return 0;
}
