/*
    This file is part of the UNF library / toolset
    Copyright (C) 2000 Steffen Kaiser

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* $RCSfile: UNF_GET.C $
   $Locker: ska $	$Name:  $	$State: Exp $

	unf_get() - Retrieves data from DOS-65-XX

*/

#if defined(__TURBOC__)
#include <dos.h>
#endif

#include "unf.loc"

#ifdef _MICROC_
#endif
#include <dos.h>
#include <string.h>

#include "unf_post.loc"

#ifdef RCS_Version
static char const rcsid[] = 
	"$Id: UNF_GET.C 1.1 2000/06/17 22:32:11 ska Exp ska $";
#endif

#if !defined(FP_OFF)
#define FP_OFF(p) (unsigned short)(p)
#endif
#if !defined(FP_SEG)
#define FP_SEG(p) (unsigned short)((unsigned long)(void far *)(p) >> 16)
#endif


int unf_get(int subfct, struct UNF_IN_BUFFER *iBuf)
{	int rc;
#if defined(__TURBOC__)
	iBuf->subFct = 0xff;	/* make sure error conditions are detected */
	_DI = FP_OFF(iBuf);
	_BX = FP_SEG(iBuf);
	_CX = sizeof(*iBuf);
	_AL = subfct;
	asm {
		push es
		mov es, bx
		mov ah, 65h
		mov bx, -1		; /* DX = BX = default country/cp */
		mov dx, bx
		int 21h
		pop es
	}
	rc = _AX;
#else
	union REGS r;
	struct SREGS sr;
	
	iBuf->subFct = 0xff;
	segread(&sr);
	r.x.di = FP_OFF(iBuf);
	sr.es = FP_SEG(iBuf);
	r.x.cx = sizeof(*iBuf);
	r.h.ah = 0x65;
	r.h.al = subfct;
	r.x.bx = 0xffffU;	/* DX = BX = default country/cp */
	r.x.dx = 0xffffU;
	intdosx(&r, &r, &sr);
	rc = r.x.ax;
#endif
	if(iBuf->subFct != subfct) {
		/* clear all the buffer to make sure the caller doesn't
			use random settings */
		memset((UBYTE*)iBuf + 1, 0, sizeof(*iBuf) - 1);
		return rc;
	}
	return 0;
}

